<template>
  <div class="spot-path">
    <div class="spot-path__row">
      <div class="spot-path__from">
        <div class="spot-path__date">
          {{ dateFrom | date }}
        </div>
        <div class="spot-path__time">
          {{ transformTime(dateFrom) }}
        </div>
      </div>
      <div v-if="route" class="spot-path__distance">
        <i class="icon route" />
        {{ route }} км
      </div>
      <div
          v-if="!!additionalNumber"
          class="spot-path__icon spot-path__route"
      >
        + {{ additionalNumber }}
      </div>
      <div class="spot-path__from">
        <div class="spot-path__date">
          {{ dateTo | date }}
        </div>
        <div class="spot-path__time">
          {{ transformTime(dateTo) }}
        </div>
      </div>
    </div>
    <div class="spot-path__row spot-path__point">
      <div class="spot-path__point-dots"></div>
    </div>
    <div :class="['spot-path__row', {'_carrier': isCarrier}]">

      <!-- LOADING -->
      <div class="spot-path__address-l">
        <div class="spot-path__address _loaded" v-for="point in loadingPoints"
             :key="point.pointType + '_' + point.sequence">
          <ObTooltip v-if="isCarrier" :content="point.addressTitle" position="bottom-end">
            <div class="spot-path__point-start"></div>
          </ObTooltip>
          <template v-else>
            <div class="spot-path__point-start"></div>
          </template>
          <div class="spot-path__address-city">
            {{ point.locationTitleRu }}
          </div>
          <div class="spot-path__address-street">
            {{ point.addressTitle }}
          </div>
        </div>
      </div>

      <!-- UNLOADING -->
      <div class="spot-path__address-unl">
        <div class="spot-path__address _uploaded" v-for="point in unloadingPoints"
             :key="point.pointType + '_' + point.sequence">
          <ObTooltip v-if="isCarrier" :content="point.addressTitle" position="bottom-end">
            <div class="spot-path__point-end"></div>
          </ObTooltip>
          <template v-else>
            <div class="spot-path__point-end"></div>
          </template>
          <div class="spot-path__address-city">
            {{ point.locationTitleRu }}
          </div>
          <div class="spot-path__address-street">
            {{ point.addressTitle }}
          </div>
        </div>
      </div>
    </div>
    <div class="spot-path__list" @click="onOpenPointModal">
      Показать маршрут списком
    </div>
    <ObModal
        ref="path-modal"
        size="large"
        :title="modalTitle"
        :isReadOnly="true"
        :isShowControls="false"
    >
      <ObTable ref="path-modal-table" :items="points" :columns="columns">
        <template #date="{ data }">
          <dateSlot :item="data.item" />
        </template>
        <template #time="{ data }">
          <timeSlot :item="data.item" />
        </template>
        <template #address="{ data }">
          <addressSlot :item="data.item" />
        </template>
      </ObTable>
      <ObButton
          label="Закрыть"
          @click="onClosePointModal"
          class="spot-path-modal__button"
      />
    </ObModal>
  </div>
</template>

<script>
import moment from 'moment'
import ObModal from 'common-components/src/obComponents/obModal/index'
import ObTable from 'common-components/src/obComponents/obTable'
import ObButton from 'common-components/src/obComponents/obButton'
import dateSlot from '../spotListCarrier/slots/date'
import timeSlot from '../spotListCarrier/slots/time'
import addressSlot from '../spotListCarrier/slots/address'
import ObTooltip from 'common-components/src/obComponents/obTooltip'

export default {
  components: {
    ObModal,
    ObTable,
    ObButton,
    dateSlot,
    timeSlot,
    addressSlot,
    ObTooltip
  },
  data () {
    return {
      columns: [
        {
          title: 'Дата',
          key: 'date',
          slotName: 'date'
        },
        {
          title: 'Время прибытия',
          key: 'time',
          slotName: 'time'
        },
        {
          title: 'Адрес',
          key: 'address',
          slotName: 'address'
        }
      ]
    }
  },
  props: {
    role: {
      type: String,
      default: ''
    },
    locationFrom: {
      type: String,
      default: ''
    },
    locationTo: {
      type: String,
      default: ''
    },
    route: {
      type: Number,
      default: null
    },
    points: {
      type: Array,
      default: () => []
    }
  },
  computed: {
    isClient () {
      return this.role === 'client'
    },
    isCarrier () {
      return this.role === 'carrier'
    },
    dateFrom () {
      return this.getDate('LOADING')
    },
    dateTo () {
      return this.getDate('UNLOADING')
    },
    modalTitle () {
      return `Маршрут заказа ${this.locationFrom} → ${this.locationTo}`
    },
    additionalNumber () {
      if (this.loadingPoints.length > 3 && this.unloadingPoints.length > 3) {
        return this.points.length - 6
      }
      if (this.loadingPoints.length > 3 && this.unloadingPoints.length <= 3) {
        return this.points.length - this.unloadingPoints.length - 3
      }
      if (this.loadingPoints.length <= 3 && this.unloadingPoints.length > 3) {
        return this.points.length - this.loadingPoints.length - 3
      } else {
        return 0
      }
    },
    loadingPoints () {
      return this.points.filter(point => point.pointType === 'LOADING')
    },
    unloadingPoints () {
      return this.points.filter(point => point.pointType === 'UNLOADING')
    }
  },
  methods: {
    getTheFirstPoint (direction) {
      return this.points.find((point) => point.pointType === direction)
    },
    getDate (direction) {
      const point = this.getTheFirstPoint(direction)
      return point ? point.arrivedAt : '–'
    },
    transformTime (time) {
      return moment(time).format('HH:mm')
    },
    onOpenPointModal () {
      this.$refs['path-modal'].open()
    },
    onClosePointModal () {
      this.$refs['path-modal'].close()
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';

.spot-path {
  font-size: 12px;
  line-height: 16px;
  letter-spacing: 0.2px;
  width: 100%;

  &__row {
    position: relative;
    width: 100%;
    display: flex;
    justify-content: space-between;
    margin-top: 20px;
  }

  &__date {
    color: $color-text-base;
  }

  &__time {
    color: $gray-slate;
  }

  &__distance {
    display: flex;
    font-weight: bold;
    font-size: 12px;
    line-height: 12px;
    letter-spacing: 0.4px;
    color: $gray-slate;
    align-items: center;
    position: absolute;
    left: 50%;
    transform: translate(-50%, 0);

    .icon {
      font-size: 16px;
      margin-right: 6px;
    }
  }

  &__icon {
    position: absolute;
    font-weight: bold;
    left: 50%;
    top: 220%;
    transform: translate(-50%, 0);
  }

  &__route {
    background: $style-white;
    padding: 0 3px;
    font-size: 10px;
    line-height: 15px;
    letter-spacing: 1px;
    color: $color-blue-navy-blue;
    border: 1px solid $color-blue-heavenly;
    border-radius: 5px;
    z-index: 1;
  }

  &__point {
    display: flex;
    justify-content: space-between;
    align-items: flex-end;
    height: 28px;

    &-start,
    &-end {
      &:before,
      &:after {
        cursor: pointer;
      }
    }

    &-start,
    &-end {
      background: $account-path_point_dots;
      width: 1px;
      height: 20px;
      position: relative;
      margin-top: -41px;

      &:before {
        width: 0;
        height: 0;
        border-style: solid;
        content: '';
        position: absolute;
        top: -8px;
      }

      &:after {
        width: 6px;
        height: 6px;
        border-radius: 50%;
        position: absolute;
        content: '';
        background: $account-path_point_dots;
        bottom: -2px;
        left: -2px;
      }
    }

    &-start {
      &:before {
        border-width: 10px 6px 0 6px;
        border-color: $diamond-orange-yellow transparent transparent transparent;
        left: -6px;
      }
    }

    &-end {
      &:before {
        border-width: 0 6px 10px 6px;
        border-color: transparent transparent $color-green-light transparent;
        right: -5px;
      }
    }

    &-last {
      margin-left: 120px;
    }

    &-right {
      margin-right: 60px;
    }

    &-dots {
      flex-grow: 12;
      height: 1px;
      border: 1px dashed $account-path_point_dots;
    }
  }

  &__address {
    &-l, &-unl {
      flex: 0 0 50%;
      display: flex;
      justify-content: flex-start;

      .spot-path__address:nth-of-type(n + 4) {
        display: none;
      }
    }

    &-unl {
      flex-flow: row-reverse nowrap;
    }
  }

  &__address {
    min-width: 120px;
    max-width: 130px;
    padding-right: 10px;
    display: flex;
    flex-direction: column;
    font-size: 10px;
    line-height: 16px;

    &-city {
      color: $shale-gray;
      font-weight: bold;
      text-transform: uppercase;
      padding-top: 10px;
    }

    &-street {
      font-size: 12px;
      color: $gray-slate;
    }

    &._uploaded {
      padding-right: 0;
      padding-left: 10px;
      position: relative;
      text-align: right;

      .spot-path__point-end {
        position: relative;
        left: 100%;
      }
    }
  }

  &__list {
    color: $color-blue-navy-blue;
    padding-top: 10px;
    font-size: 12px;
    line-height: 12px;
    letter-spacing: 0.4px;

    &:hover {
      cursor: pointer;
    }
  }

  &-modal {
    &__button {
      color: $style-white !important;
      background: $color-blue-navy-blue !important;
      border-radius: 10px;
      margin-top: 30px;
    }
  }

  /* style for CARRIER's role */
  ._carrier {
    .spot-path__address-city,
    .spot-path__address-street {
      display: none;
    }

    .spot-path__address {
      min-width: 60px;
      max-width: 60px;
      padding-right: 5px;

      &:first-child {
        .spot-path__address-city,
        .spot-path__address-street {
          display: block;
          min-width: 150px;
          padding-top: 0;
        }
      }

      &._uploaded:first-child {
        .spot-path__address-city,
        .spot-path__address-street {
          margin-left: -150px;
        }
      }
    }
  }
}
</style>
